/************************************************************/
/* mail: King_of_Freaks@ist-einmalig.de                     */
/* ICQ:  344921113                                          */
/************************************************************/
/* Grundfunktionen fr die Kommunikation mit dem CAN-Bus    */
/* und dem MSP430. Der Code Funktioniert soweit (senden &   */
/* empfangen) was jedoch nicht heit, das er frei von       */
/* fehlern ist. Hast du einen Fehler gefunden? Ja? Dann     */
/* sei so gut und informiere mich bitte.                    */
/************************************************************/
/* Getestet mit:                                            */
/* MSP430F149 mit 8MHz Quarz (SPI bei 1 MHz)                */
/* MCP2510-I/SO mit 2MHz Quarz (kompatibel zu MCP2515)      */
/* SN65HVD232D (1MBit 3,3V Transreciver)                    */
/* MAX3233EEWP (RS232 3,3V  Transreciver)                   */
/************************************************************/
/* bugs:                                                    */
/* - zur zeit gehen nur daten ber den rx1 ein. (es wird    */
/*   wohl an der initialisierung liegen)                    */
/* - befinden sich 2. oder mehr Frames auf dem Bus, so wird */
/*   ein Interrupt ausgelst, den ich noch nicht            */
/*   interpretieren konnte. In diesem Fall wird NICHTS      */
/*   in die RX Buffer geschrieben und der Interrupt muss    */
/*   gelscht werden! (Kollision von Daten?)                */
/************************************************************/

#ifndef __CAN_NEW_H__
#define __CAN_NEW_H__

#include "tools.h"

void write_mcp(byte addr, byte value);
void reset_mcp(void);
byte read_mcp(byte addr);
void can_mode(byte mode);
void can_write_many_registers(byte reg, byte len,byte *dta);
void can_write_id(byte mcp_addr, byte ext, dword can_id);
void can_init(void);
byte can_state(void);
byte can_chk(void);
void can_modify_register(byte regaddr, byte mask, byte regvalue);
void can_int_clear(void);
void can_clear_rx0(void);
void can_clear_rx1(void);
void can_tx0(dword can_id, byte ext_id, byte dlc, byte *dta);
void can_tx1(dword can_id, byte ext_id, byte dlc, byte *dta);
void can_tx2(dword can_id, byte ext_id, byte dlc, byte *dta);
void can_rx0(dword *can_id, byte *ext_id, byte *dlc);
void can_rx1(dword *can_id, byte *ext_id, byte *dlc);
void can_read_id(byte mcp_addr, byte* ext, dword* can_id);
void can_read_many_registers(byte regaddr, byte len, byte *dta);


#endif
