#include <string.h>
#include <msp430x14x.h>


void cout( char c ) 
{
	  while ((IFG2 & UTXIFG1) == 0);
	  TXBUF1 = (unsigned char)c;
}

void sout( char * str ) 
{
	    while (*str != 0) 
	    {
			cout(*str++);        //write char and increment pointer
	    }
}

void reverse(char str[])
{
	    int c, i, j;
	    for(i = 0,j = strlen(str)-1; i < j; i++, j--)
	    {
			c = str[i];
			str[i] = str[j];
			str[j] = c;
	    }
}

void IntToString(char str[], int value)
{
	    int i, sign;
	     
	    if((sign = value) < 0 )
	    {
			value = -value;
	    }
	    i = 0;
	    do
	    {
			str[i++] = value %10 + '0';
	    }
	    while((value /= 10) >0);
	    if (sign < 0)
	    {
			str[i++] = '-';
	    }
	    str[i] = '\0';
	    reverse(str);
}

void wait(unsigned int i)      // wartet i * 0,1ms
{                                      
	unsigned int j, k;
	for(k=0;k<5;k++)
		for(j=0;j<i;j++);
}

void DecToString (unsigned char *str, int value, unsigned char max_chars, unsigned char type)
{
	  unsigned char i=0;
	  unsigned char digit_count=0;
	  unsigned char leading_count=0;  // number of _needed_ leading characters
	  unsigned int factor=1;
	  unsigned char number=0;
	
	  while(value / factor)
	  {
	    digit_count++;        // count digits
	    factor *= 10;         // calculate factor
	  }
	  factor /= 10;
	
	  if (digit_count)
	    leading_count = max_chars - digit_count;
	  else
	    leading_count = max_chars - digit_count - 1;
	
	  while(i < leading_count)
	  {                       // fill up leading chars
	    if(type)
	      str[i++]=' ';
	    else
	       str[i++]='0';
	  }
	
	  if (digit_count)
	  {
	    while(factor)
	    {                     // convert int to chars
	      number = value / factor; 
	      value %= factor;
	      factor /= 10;
	      str[i++] = number + 48;
	    }
	  }
	  else
	  {
	    str[i++]='0';         // keep at least one zero!
	  }
	  str[i++]='\0';
}

void ultoa(unsigned long n,int base,char *dst, unsigned char dstlen)
{
	char buf[3*sizeof(unsigned long) + 1];
	char *bufend = buf + sizeof(buf);
	size_t len;
	char *p;
	static char hex[] = "0123456789abcdef";

	p = bufend;
	*--p = '\0';
	if (base == 10) {
		do {
			*--p = n%10 + '0';
			n /= 10;
		} while (n != 0);
	} else if (base == 16) {
		do {
			*--p = hex[n&0xf];
			n >>= 4;
		} while (n != 0);
		*--p = 'x';
		*--p = '0';
	} else if (base == 8) {
		do {
			*--p = (n&07) + '0';
			n >>= 3;
		} while (n != 0);
		*--p = '0';
	} else
		*--p = '?';

	len = bufend - p;

	if (dstlen > 0) {
		if (len > dstlen)
			*(p + dstlen - 1) = '\0';
		strcpy(dst, p);
	}
}
